/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 09.09.2022
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega8.h>

#include <delay.h>

// 1 Wire Bus interface functions
#include <1wire.h>

// DS1820 Temperature Sensor functions
#include <ds18b20.h>
#include <i2clcd.h>
#include <stdio.h>



// Declare your global variables here
volatile unsigned int fen_temp= 150; //   
volatile unsigned int sold_temp= 100; //   
volatile bit set_sold = 0;
volatile bit set_fen = 0;
volatile int cnt_sol = 0;
volatile int cnt_fen = 0;
bit fen_en = 0; 
bit sold_en = 0;
bit gerkon = 0;
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
if ((PIND.0 == 0) && (PIND.2 == 0) && (sold_temp < 350))   
    sold_temp=sold_temp+10;  
if ((PIND.0 == 1)&& (PIND.2 == 0) && (sold_temp > 100))
    sold_temp=sold_temp-10;      
set_sold = 1;
cnt_sol=0; 
GICR|=(0<<INT0);
}


// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
if ((PIND.1 == 0) && (PIND.3 == 0) && (fen_temp < 500) )
   fen_temp++;
if ((PIND.1 == 1)&& (PIND.3 == 0) && (fen_temp > 150))
    fen_temp=fen_temp-1; 
set_fen = 1;
cnt_fen=0; 
GICR|=(0<<INT1);
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x06;
cnt_sol++;
cnt_fen++;
// Place your code here

}

// Voltage Reference: AVCC pin
#define ADC_VREF_TYPE ((0<<REFS1) | (1<<REFS0) | (0<<ADLAR))

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | ADC_VREF_TYPE;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=(1<<ADSC);
// Wait for the AD conversion to complete
while ((ADCSRA & (1<<ADIF))==0);
ADCSRA|=(1<<ADIF);
return ADCW;
}

void main(void)
{
long fen_tc = 0;
long sold_tc = 0;
unsigned char lcd_buffer_fen[16]; 
unsigned char lcd_buffer_sold[16];
int temp = 0; //   
unsigned char devices;

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=In 
DDRB=(0<<DDB7) | (0<<DDB6) | (1<<DDB5) | (1<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (0<<DDB0);
// State: Bit7=T Bit6=T Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=T 
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
// State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
// State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 250,000 kHz
TCCR0=(0<<CS02) | (1<<CS01) | (1<<CS00);
TCNT0=0x06;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 16000,000 kHz
// Mode: Fast PWM top=0x00FF
// OC1A output: Non-Inverted PWM
// OC1B output: Non-Inverted PWM
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 0,016 ms
// Output Pulse(s):
// OC1A Period: 0,016 ms Width: 0 us
// OC1B Period: 0,016 ms Width: 0 us
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=(1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (1<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Low level
// INT1: On
// INT1 Mode: Low level
GICR|=(1<<INT1) | (1<<INT0);
MCUCR=(0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
GIFR=(1<<INTF1) | (1<<INTF0);

// USART initialization
// USART disabled
UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (0<<RXEN) | (0<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: AVCC pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (1<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
SFIOR=(0<<ACME);

// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);

// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);

// 1 Wire Bus initialization
// 1 Wire Data port: PORTD
// 1 Wire Data bit: 4
// Note: 1 Wire port settings are specified in the
// Project|Configure|C Compiler|Libraries|1 Wire menu.
delay_ms(100);
lcd_init();
delay_ms(100);
// Global enable interrupts
#asm("sei")
devices=w1_init();
delay_ms(1000);
if (devices>0)
 {
  temp = ds18b20_temperature(0); // ...
  if (temp>1000)
     {
    temp=4096-temp;
    temp=-temp;
    }
 }
 else
temp=25;
lcd_clear();
lcd_gotoxy(2, 0);
lcd_puts("Solder station");
lcd_gotoxy(4, 1);
lcd_puts("ver. 2.0");
delay_ms(3000);
lcd_clear();
fen_tc = read_adc(0);//  
sold_tc = read_adc(1); //  
while (1)
   {
      OCR1BH=0x00;   
      if ((read_adc(0)/4)<=255)          //    
      OCR1BL=read_adc(0)/4;   
      else  
      OCR1BL=0xFF;   
         //  
      if (fen_en == 0)// 
        {
        PORTB.3 = 0; //  
        PORTB.5 = 1; //     
        lcd_gotoxy(0, 0);
        lcd_puts("Temp.fena = off  "); //  
        } 
      if (sold_en == 0)   // 
        {
        PORTB.4 = 1; //  
        OCR1AL=0x00;
        lcd_gotoxy(0, 1);
        lcd_puts("Temp.sold = off  ");
        }
      if ((PIND.5 == 0)&&(fen_en == 0)) //     
        {
        while (PIND.5 == 0) //       
        fen_en = 1;
        }
      if ((PINB.0 == 0)&&(sold_en == 0)) //     
        {
        while (PINB.0 == 0)      
        sold_en = 1;    
        }   
      if ((PIND.5 == 0)&&(fen_en == 1)) //     
        {
        while (PIND.5 == 0)      
        fen_en = 0;
        }
      if ((PINB.0 == 0)&&(sold_en == 1)) //     
        {
        while (PINB.0 == 0)      
        sold_en = 0;  
        }
              //  
              //    
      if (sold_en == 1)
         {
          sold_tc = (long)340*read_adc(1)/614+temp; //  
            if (sold_tc<(sold_temp-5)) //       
             {
              PORTB.4 = 0;   // 
              OCR1AL=0xFF;//    
             } 
            if (sold_tc>(sold_temp+5)) //       
             {
              PORTB.4 = 1;  // 
              OCR1AL=0x00; //  
             }       
             if ((sold_tc>(sold_temp-5)) && (sold_tc<(sold_temp+5))) //                 
             { 
              OCR1AL=255-(((sold_temp+ 5)-sold_tc)*25);
              PORTB.4 = 1;  // 
              }
          } 
          //   
         //  
      if (fen_en == 1)
          {               
         fen_tc =(long)511*read_adc(2)/717+temp;//  
               if (fen_tc<(fen_temp-10))   //    
                {
                PORTB.5 = 0;//  
                PORTB.3 = 1;//  
                }
            if (fen_tc>(fen_temp+10))
                {
                PORTB.5 = 1;//      
                PORTB.3 = 0;//   
                }
          }
          if ((PINC.5 == 0) && (fen_en == 1)) 
              {
              fen_en = 0;
              gerkon = 1;
              }
       if ((PINC.5 == 1) && (gerkon == 1))
           {
           fen_en = 1;
           gerkon = 0;
           }
          //   
       // 
        if (sold_en == 1)
         {
         if (set_sold == 1)    
            {     
            cnt_sol=0;
            while (cnt_sol< 3000)     
            {          
            if ((PIND.1 == 1) && (PIND.3 == 1))
            GICR|=(1<<INT1);
            sprintf(lcd_buffer_sold, "Temp.sold=%i\xdf" "C", sold_temp);
            lcd_gotoxy(0, 1);
            lcd_puts(lcd_buffer_sold);
            }    
            set_sold = 0;
            }    
          if ((set_sold == 0) && (cnt_sol > 2000))
            {        
            if (sold_tc < 100)
            sprintf(lcd_buffer_sold, "Temp.sold=%i\xdf" "C ", sold_tc);
            else
            sprintf(lcd_buffer_sold, "Temp.sold=%i\xdf" "C", sold_tc);
            lcd_gotoxy(0, 1);
            lcd_puts(lcd_buffer_sold);
            cnt_sol = 0; 
            }
         }
         if (fen_en == 1)
         {
         if (set_fen == 1)
             {            
             cnt_fen=0;
              while (cnt_fen< 3000)
              {   
              if ((PIND.0 == 1) && (PIND.2 == 1))
               GICR|=(1<<INT0);    
              sprintf(lcd_buffer_fen, "Temp.fena=%i\xdf" "C", fen_temp);
              lcd_gotoxy(0, 0);
              lcd_puts(lcd_buffer_fen);     
              } 
              set_fen = 0;
             } 
           if ((set_fen == 0) && (cnt_fen > 2000))    
             {              
             if (fen_tc < 100)
             sprintf(lcd_buffer_fen, "Temp.fena=%i\xdf" "C ", fen_tc);
             else
             sprintf(lcd_buffer_fen, "Temp.fena=%i\xdf" "C", fen_tc);
             lcd_gotoxy(0, 0);
             lcd_puts(lcd_buffer_fen); 
             cnt_fen = 0;
             }
         }
                
      } //  while
}  //  main
